MirrorlandGuildHalls = {
	name = "MirrorlandGuildHalls",
	Guilds = {
		[600784] = true,	--MirrorLand
		[650690] = true,	--WonderLand
		[699342] = true,	--DreamLand
		[713814] = true,	--LostLand
		[532288] = true, 	--TronRu
		[733034] = true, 	--Stolyarka
		},
	Label = "ГИЛЬДХОЛЛЫ",
	LabelFont = "ZoFontWinH4",
	Position={TOP,nil,TOP,40,5},
	ButtonSize=36,
	Space=2,
}

local ButtonData={
[1]={
	tooltip="[Ru] Вилла",
	house={"@SiameseCat", 62},
	icon={"MirrorlandGuildHalls/imgs/GH_buttons/ML_st.dds", "MirrorlandGuildHalls/imgs/GH_buttons/ML_act.dds"},
	},
[2]={
	tooltip="[Ru] Остров",
	house={"@NataLiyaN", 62},
	icon={"MirrorlandGuildHalls/imgs/GH_buttons/TRN_st.dds", "MirrorlandGuildHalls/imgs/GH_buttons/TRN_act.dds"},
	},
[3]={
	tooltip="[En] Пляж",
	house={"@Mirror_Cat", 40},
	icon={"MirrorlandGuildHalls/imgs/GH_buttons/WL_st.dds", "MirrorlandGuildHalls/imgs/GH_buttons/WL_act.dds"},
	},
[4]={
	tooltip="[Ru] Поместье",
	house={"@Lost.Seeker", 46},
	icon={"MirrorlandGuildHalls/imgs/GH_buttons/LL_st.dds", "MirrorlandGuildHalls/imgs/GH_buttons/LL_act.dds"},
	},
}

local function MakeButton(control,num)
	local w,space=MirrorlandGuildHalls.ButtonSize,MirrorlandGuildHalls.Space
	local data=ButtonData[num]
	local name="ZO_GuildHome_MLGH_Button"..num
	local button=_G[name] or WINDOW_MANAGER:CreateControl(name, control, CT_BUTTON)
	button:SetDimensions(w,w)
	button:ClearAnchors()
	local shift=(128-(w+space)*#ButtonData)/2
	button:SetAnchor(TOPLEFT,control,TOPLEFT,shift+(w+space)*(num-1),25)
	button:SetHidden(false)
	button:SetNormalTexture(data.icon[1])
	button:SetMouseOverTexture(data.icon[2])
	button:SetMouseEnabled(true)
	button:SetDrawTier(DT_MEDIUM)
	button:SetDrawLayer(DL_CONTROLS)
	button:SetHandler("OnMouseEnter", function(self)
		PlaySound(SOUNDS.BOOK_METAL_PAGE_TURN)
		if data.tooltip then
			local tooltip=data.tooltip
			ZO_Tooltips_ShowTextTooltip(self, BOTTOM, (type(tooltip)=="string" and tooltip or tooltip()))
		end
	end)
	button:SetHandler("OnMouseExit", function(self)
		if data.tooltip then ZO_Tooltips_HideTextTooltip() end
	end)
	button:SetHandler("OnMouseDown", function(self)
		if data.house then
			if (GetDisplayName() == data.house[1]) then
				RequestJumpToHouse(data.house[2])
				d(MRR.."Да, давай осмотрим наши владения.|r")
			else
				JumpToSpecificHouse(data.house[1],data.house[2])
				d(MRR.."Уиии! Летим в наш гильдейский дом!|r")
			end
		end
	end)
end

local function UI_Init()
	local control=ZO_GuildHome_MLGH or WINDOW_MANAGER:CreateControl("ZO_GuildHome_MLGH", ZO_GuildHome, CT_CONTROL)
	local pos=MirrorlandGuildHalls.Position
	control:SetDimensions(128,64)
	control:ClearAnchors()
	control:SetAnchor(pos[1],ZO_GuildHome,pos[3],pos[4],pos[5])
	control:SetHidden(false)

	local label=ZO_GuildHome_Label or WINDOW_MANAGER:CreateControl("ZO_GuildHome_Label", control, CT_LABEL)
	label:SetDimensions(128,20)
	label:ClearAnchors()
	label:SetAnchor(TOPLEFT,control,TOPLEFT,0,0)
	label:SetFont(MirrorlandGuildHalls.LabelFont)
	label:SetColor(.9,.9,.8,1)
	label:SetHorizontalAlignment(1)
	label:SetVerticalAlignment(0)
	label:SetText(MirrorlandGuildHalls.Label)
	label:SetHidden(false)

	for num in pairs(ButtonData) do
		MakeButton(control,num)
	end
end

		--Текстуры
	lmb = '|t25:25:ESOUI/art/miscellaneous/icon_lmb.dds|t'
	rmb = '|t25:25:ESOUI/art/miscellaneous/icon_rmb.dds|t'
	dvd = '|t200:2:esoui/art/ava/ava_seigecontrols_divider.dds|t'
	CRN = '|t25:25:esoui/art/icons/guildranks/guild_indexicon_misc01_up.dds|t'
	menuGH = '|t25:25:esoui/art/journal/leaderboard_tabicon_home_up.dds|t'
	GDscl = '|t25:25:esoui/art/chatwindow/chat_friendsonline_up.dds|t'
	GDtrd = '|t25:25:esoui/art/tradinghouse/tradinghouse_sell_tabicon_up.dds|t'
	GDpvp = '|t25:25:esoui/art/hud/gamepad/gp_radialicon_duel_disabled.dds|t'
			--/esoui/art/hud/radialicon_duel_disabled.dds
	ADD = '|t25:25:esoui/art/progression/addpoints_up.dds|t'
	Discord = '|t25:25:esoui/art/help/help_tabicon_cs_disabled.dds|t'
	RUI = '|t25:25:esoui/art/ava/ava_keepstatus_icon_collectionrate.dds|t'
	GDB = '|t25:25:esoui/art/contacts/gamepad/gp_social_status_dnd.dds|t'
	QST = '|t25:25:esoui/art/help/help_tabicon_questassistance_up.dds|t'
	RCH = '|t25:25:esoui/art/tutorial/gamepad/gp_journalcheck.dds|t'
			--/esoui/art/hud/gamepad/gp_radialicon_accept_down.dds | tabicon_history_up.dds | help_tabicon_overview_up.dds
	GT = '|t25:25:esoui/art/contacts/tabicon_friends_up.dds|t'
	WSr = '|t25:25:esoui/art/icons/poi/poi_wayshrine_complete.dds|t'
	WCity = '|t25:25:esoui/art/icons/poi/poi_city_complete.dds|t'
	GCN = '|t20:20:esoui/art/loot/icon_goldcoin_pressed.dds|t'
	
	Web = '|t25:25:esoui/art/guild/tabicon_history_up.dds|t'
		--Имя
	MRR = '|c5c73ed[|t25:25:esoui/art/icons/justice_stolen_mirror_001.dds|t]|r: |cb8dbdd'
	--|cb8dbdd
	--|c0de3fc
	
		--Локации
	LocGrahtwood	=	'|cffdb58Гратвуд|r'
	LocStormhaven	=	'|c02729bСтормхейвен|r'
	LocDeshaan		=	'|cb2341fДешаан|r'
			-----
	LocCraglorn		=	'|cbfbc99Краглорн|r'
	LocCHarbour		=	'|cbfbc99Хладная Гавань|r'
			-----
	LocVvardenfell	=	'|cb58e49Вварденфелл|r'
	LocSummerset	=	'|cb58e49Саммерсет|r'
	LocNortEls		=	'|cb58e49Северный Эльсвейр|r'
	LocWestSky		=	'|cb58e49Западный Скайрим|r'
	LocBlWood		=	'|cb58e49Черный Лес|r'
	LocHIsle		= 	'|cb58e49Высокий Остров|r'
	
		--Города
	CityEldenRoot	=	'|cffdb58Элден-Рут|r'
	CityWayrest		=	'|c02729bВэйрест|r'
	CityMournhold	=	'|cb2341fМорнхолд|r'
			-----
	CityBelkarth	=	'|cbfbc99Белкарт|r'
    CityHollowCity	=	'|cbfbc99Опустошенный город|r'
			-----
	CityVivec		=	'|cb58e49Вивек|r'
	CityAlinor		=	'|cb58e49Алинор|r'
	CityRimmen		=	'|cb58e49Риммен|r'
	CitySolitude	=	'|cb58e49Солитьюд|r'
	CityLeyawiin	=	'|cb58e49Лейавин|r'
	CityGonfalon	=	'|cb58e49Знаменная Гавань|r'
	
	
function MirrorlandGuildHalls:InitializeChatButton()
		--Тултип
local function ShowTooltip(control)
		InitializeTooltip(InformationTooltip, control, TOPLEFT, 5, -10, BOTTOMRIGHT)
		InformationTooltip:AddLine(""..CRN.."|cBFBC99MirrorLand Community|r"..CRN.."")
		InformationTooltip:AddVerticalPadding(-15)
		InformationTooltip:AddLine(""..dvd.."")
		InformationTooltip:AddVerticalPadding(-10)
		InformationTooltip:AddLine(""..lmb.."|cBFBC99Меню|r"..rmb.."|cBFBC99Сообщество|r")
    end  
local function HideTooltip(control)
		ClearTooltip(InformationTooltip)
    end
	
		--Меню
local function MLC_Menu(control, button)
	if button == 2 then
		local SubMenuML = {
				{label = ""..ADD.."Вступить", callback = function() ZO_LinkHandler_OnLinkClicked("|H1:guild:600784|hMirrorLand|h", 1) end,},
				{label = "-", },
				{label = ""..Discord.."Дискорд", callback = function() RequestOpenUnsafeURL("https://discord.gg/fwKtUFX") end,},
			}
		local SubMenuWL = {
				{label = ""..ADD.."Вступить", callback = function() ZO_LinkHandler_OnLinkClicked("|H1:guild:650690|hWonderIand|h", 1) end,},
				{label = "-", },
				{label = ""..Discord.."Дискорд", callback = function() RequestOpenUnsafeURL("https://discord.gg/fwKtUFX") end,},
			}
		local SubMenuDL = {
				{label = ""..ADD.."Вступить", callback = function() ZO_LinkHandler_OnLinkClicked("|H1:guild:699342|hDreamIand|h", 1) end,},
				{label = "-", },
				{label = ""..Discord.."Дискорд", callback = function() RequestOpenUnsafeURL("https://discord.gg/fwKtUFX") end,},
			}
		local SubMenuLL = {
				{label = ""..ADD.."Вступить", callback = function() ZO_LinkHandler_OnLinkClicked("|H1:guild:713814|hLostLand|h", 1) end,},
				{label = "-", },
				{label = ""..Discord.."Дискорд", callback = function() RequestOpenUnsafeURL("https://discord.gg/fwKtUFX") end,},
			}
		local SubMenuTRN = {
				{label = ""..ADD.."Вступить", callback = function() ZO_LinkHandler_OnLinkClicked("|H1:guild:532288|hTronRU|h", 1) end,},
				{label = "-", },
				{label = ""..Discord.."Дискорд", callback = function() RequestOpenUnsafeURL("https://discord.gg/RqMymF9") end,},
			}
		local SubMenuCHR = {
				{label = ""..ADD.."Вступить", callback = function() ZO_LinkHandler_OnLinkClicked("|H1:guild:733034|hStolyarka|h", 1) end,},
				{label = "-", },
				{label = ""..Discord.."Дискорд", callback = function() RequestOpenUnsafeURL("https://discord.gg/fwKtUFX") end,},
			}
			ClearMenu()
			AddCustomMenuItem(""..Web.."Наш сайт", function() RequestOpenUnsafeURL("https://mlc-teso.ru/") end)
			AddCustomMenuItem("-", function() end)
			AddCustomSubMenuItem(""..GDscl.."MirrorLand", SubMenuML)
			AddCustomSubMenuItem(""..GDscl.."WonderLand", SubMenuWL)
			AddCustomSubMenuItem(""..GDscl.."DreamLand", SubMenuDL)
			AddCustomSubMenuItem(""..GDscl.."LostLand", SubMenuLL)
			AddCustomSubMenuItem(""..GDscl.."TronRu", SubMenuTRN)
			AddCustomSubMenuItem(""..GDpvp.."Stolyarka", SubMenuCHR)
			ShowMenu()
	elseif button == 1 then
		local entries = {
				{label = ""..menuGH.."[Ru] Вилла", callback = function() MirrorlandGuildHalls:PortToHouse("@SiameseCat", 62) end, },
				{label = "-", },
				{label = ""..menuGH.."[Ru] Остров", callback = function() MirrorlandGuildHalls:PortToHouse("@NataLiyaN", 62) end, },
				{label = "-", },
				{label = ""..menuGH.."[En] Пляж", callback = function() MirrorlandGuildHalls:PortToHouse("@Mirror_Cat", 40) end, },
				{label = "-", },
				{label = ""..menuGH.."[Ru] Поместье", callback = function() MirrorlandGuildHalls:PortToHouse("@Lost.Seeker", 46) end, },
            }
		local MLCGroupMenu = {
				{label = ""..CRN.."К лидеру", callback = function() d(MRR.."Полетели на коронку!|r") JumpToGroupLeader() end,},
				{label = ""..QST.."Поделиться заданиями", callback = function() MirrorlandGuildHalls.ShareAllDailies() end,},
				{label = "-", },
				{label = ""..GDB.."|c880000Выйти из группы|r", callback = function() GroupLeave() end,},
			}
		local MLCGroupMenuGL = {
				{label = ""..RCH.."Проверка готовности", callback = function() d(MRR.."ВСЕ ГОТОВЫ?!|r") ZO_SendReadyCheck() end, },
				{label = ""..QST.."Поделиться заданиями", callback = function() MirrorlandGuildHalls.ShareAllDailies() end,},
				{label = "-", },
				{label = ""..GDB.."|c880000Выйти из группы|r", callback = function() GroupLeave() end,},
				{label = ""..GDB.."|c880000Распустить группу|r", callback = function() GroupDisband() end, }, 
			}
		local MLCLocMenu = {
				{label = ""..WSr..""..LocGrahtwood.."", callback = function() 	MirrorlandGuildHalls.Teleport(181) end, },		--Гратвуд
				{label = ""..WSr..""..LocStormhaven.."", callback = function() 	MirrorlandGuildHalls.Teleport(4) end, },		--Стормхейвен
				{label = ""..WSr..""..LocDeshaan.."", callback = function() 	MirrorlandGuildHalls.Teleport(10) end, },		--Дешаан
				{label = "-", },
				{label = ""..WSr..""..LocCraglorn.."", callback = function() 	MirrorlandGuildHalls.Teleport(501) end, },		--Краглорн
				{label = ""..WSr..""..LocCHarbour.."", callback = function() 	MirrorlandGuildHalls.Teleport(155) end, },		--Хладная Гавань
				{label = "-", }, 
				{label = ""..WSr..""..LocVvardenfell.."", callback = function() MirrorlandGuildHalls.Teleport(468) end, },		--Вварденфелл
				{label = ""..WSr..""..LocSummerset.."", callback = function() 	MirrorlandGuildHalls.Teleport(617) end, },		--Summerset
				{label = ""..WSr..""..LocNortEls.."", callback = function() 	MirrorlandGuildHalls.Teleport(682) end, },		--Northern Elsweyr
				{label = ""..WSr..""..LocWestSky.."", callback = function() 	MirrorlandGuildHalls.Teleport(744) end, },		--Western Skyrim
				{label = ""..WSr..""..LocBlWood.."", callback = function() 		MirrorlandGuildHalls.Teleport(835) end, },		--BlackWood
				{label = ""..WSr..""..LocHIsle.."", callback = function() 		MirrorlandGuildHalls.Teleport(884) end, },		--Высокий Остров
			}
		local MLCCityMenu = {
				{label = ""..WCity..""..CityEldenRoot.."", callback = function() 	MirrorlandGuildHalls.CityTeleport(214) end, },	--EldenRoot
				{label = ""..WCity..""..CityWayrest.."", callback = function() 		MirrorlandGuildHalls.CityTeleport(56) end, },	--Wayrest
				{label = ""..WCity..""..CityMournhold.."", callback = function() 	MirrorlandGuildHalls.CityTeleport(28) end, },	--Mournhold
				{label = "-", },                                                                                                                  
				{label = ""..WCity..""..CityBelkarth.."", callback = function() 	MirrorlandGuildHalls.CityTeleport(220) end, },	--Belkarth
				{label = ""..WCity..""..CityHollowCity.."", callback = function() 	MirrorlandGuildHalls.CityTeleport(131) end, }, 	--HollowCity
				{label = "-", },                                                                                                                  
				{label = ""..WCity..""..CityVivec.."", callback = function() 		MirrorlandGuildHalls.CityTeleport(284) end, },	--Vivec
				{label = ""..WCity..""..CityAlinor.."", callback = function() 		MirrorlandGuildHalls.CityTeleport(355) end, },	--Alinor
				{label = ""..WCity..""..CityRimmen.."", callback = function() 		MirrorlandGuildHalls.CityTeleport(382) end, },	--Rimmen
				{label = ""..WCity..""..CitySolitude.."", callback = function() 	MirrorlandGuildHalls.CityTeleport(421) end, },	--Solitude
				{label = ""..WCity..""..CityLeyawiin.."", callback = function() 	MirrorlandGuildHalls.CityTeleport(458) end, },	--Leyawiin
				{label = ""..WCity..""..CityGonfalon.."", callback = function() 	MirrorlandGuildHalls.CityTeleport(513) end, },	--Знаменная Гавань
			}
			ClearMenu()
			AddCustomMenuItem(""..menuGH.."Домой", function() d(MRR.."Дом, милый дом.|r") RequestJumpToHouse(GetHousingPrimaryHouse()) end)
			AddCustomMenuItem("-", function() end)
			AddCustomSubMenuItem(""..menuGH.."Гильдхоллы", entries)
			if (IsUnitGrouped("player")) then
				AddCustomMenuItem("-", function() end)
				if not (IsUnitGroupLeader("player")) then
					AddCustomSubMenuItem(""..GT.."Груп.меню", MLCGroupMenu)
				else
					AddCustomSubMenuItem(""..GT.."Груп.меню", MLCGroupMenuGL)
				end
			end
			AddCustomMenuItem("-", function() end)
			AddCustomSubMenuItem(""..WSr.."Локации", MLCLocMenu)
			AddCustomSubMenuItem(""..WCity.."Города |cffffff"..GetRecallCost(node).."|r"..GCN.."", MLCCityMenu)
			AddCustomMenuItem("-", function() end)
			AddCustomMenuItem(""..RUI.."ReloadUI", function() ReloadUI() end)
			ShowMenu()
		end
end

		--Кнопка развернутого чата
	MLbtn =  WINDOW_MANAGER:CreateControl("MaxMLGH", ZO_ChatWindow, CT_BUTTON)
    MLbtn:SetDimensions(24, 24)
    MLbtn:SetAnchor(TOPLEFT, ZO_ChatOptionsSectionLabel, TOPLEFT, 200, 12)
   	MLbtn:SetHandler("OnMouseEnter", function(control) ShowTooltip(control) end)
    MLbtn:SetHandler("OnMouseExit", function(control) HideTooltip(control) end)
	MLbtn:SetNormalTexture("MirrorlandGuildHalls/imgs/ML_off.dds")
    MLbtn:SetPressedTexture("MirrorlandGuildHalls/imgs/ML_on.dds")
    MLbtn:SetMouseOverTexture("MirrorlandGuildHalls/imgs/ML_on.dds")
	MLbtn:SetHandler("OnMouseUp", function(control, button) MLC_Menu(control, button) end)
		
		--Кнопка свернутого чата
	MLbtnMin =  WINDOW_MANAGER:CreateControl("MinMLGH", ZO_ChatWindowMinBar, CT_BUTTON)
    MLbtnMin:SetDimensions(24, 24)
    MLbtnMin:SetAnchor(TOPLEFT, ZO_ChatWindowMinBar, nil, 0, 423)
    MLbtnMin:SetHandler("OnMouseEnter", function(control) ShowTooltip(control) end)
	MLbtnMin:SetHandler("OnMouseExit", function(control) HideTooltip(control) end)
    MLbtnMin:SetNormalTexture("MirrorlandGuildHalls/imgs/ML_off.dds")
    MLbtnMin:SetPressedTexture("MirrorlandGuildHalls/imgs/ML_on.dds")
    MLbtnMin:SetMouseOverTexture("MirrorlandGuildHalls/imgs/ML_on.dds")
	MLbtnMin:SetHandler("OnMouseUp", function(control, button) MLC_Menu(control, button) end)
end

		--Фикс для хозяев ГХ
function MirrorlandGuildHalls:PortToHouse(name, houseId)
    if (GetDisplayName() == name) then
        RequestJumpToHouse(houseId)
		 d(MRR.."Да, давай осмотрим наши владения.|r")
    else
        JumpToSpecificHouse(name, houseId)
		 d(MRR.."Уиии! Летим в наш гильдейский дом!|r")
    end
end

--------------------------------------------------------------------------------
		--Доп. функционал
--------------------------------------------------------------------------------
		
		--Диалог с банком
local bankScene = SCENE_MANAGER:GetScene("bank")
    bankScene:RegisterCallback("StateChange", function(oldState, newState)
        if newState == SCENE_SHOWN then
            MirrorlandGuildHalls.selectDeposit()
        end
    end)
		
function MirrorlandGuildHalls.selectDeposit()
    ZO_MenuBar_SelectDescriptor(ZO_PlayerBankMenuBar, SI_BANK_DEPOSIT)
end	

		--Индикатор свободного места в инвентаре
function MirrorlandGuildHalls.BagSpaceIndicator()
		bagSpaceIcon = CreateControl("BagSpaceIcon", ZO_MailInbox, CT_TEXTURE)
			bagSpaceIcon:SetDimensions(26,26)
			bagSpaceIcon:SetAnchor(LEFT, ZO_MailInboxUnread, LEFT, 5, 30)
			bagSpaceIcon:SetTexture("/esoui/art/icons/justice_stolen_pouch_001.dds")

		bagSpaceLabel = CreateControl("BagSpaceLabel", ZO_MailInbox, CT_LABEL)
			bagSpaceLabel:SetColor(1, 1, 1, 1)
			bagSpaceLabel:SetFont("ZoFontGameBold")
			bagSpaceLabel:SetText("")
			bagSpaceLabel:SetAnchor(LEFT, bagSpaceIcon, RIGHT, 7, 0)
			bagSpaceLabel:SetDimensions(80,25)
end

local function BagUpdateSpace(eventCode, mailId) 
	bagSpaceLabel:SetText(GetNumBagUsedSlots(1)..'/'..GetBagSize(1))
	if GetBagSize(1) ==	GetNumBagUsedSlots(1) then
		bagSpaceLabel:SetColor(1,0,0,1)
	elseif (GetBagSize(1)-GetNumBagUsedSlots(1)) <= 10 then
		bagSpaceLabel:SetColor(1,0.9,0,1)
	else
		bagSpaceLabel:SetColor(1, 1, 1, 1)
	end
end	
		--Удаление писем без подтверждений
--[[ZO_PreHook(MAIL_INBOX, "Delete", function( self )
	if (self.mailId and self:IsMailDeletable()) then
		local numAttachments, attachedMoney = GetMailAttachmentInfo(self.mailId)
		if (numAttachments == 0 and attachedMoney == 0) then
			local selectedMailNode = self.navigationTree:GetSelectedNode()
			if (selectedMailNode) then
				local nextOrPreviousNode = selectedMailNode:GetNextOrPreviousSiblingNode()
				if (nextOrPreviousNode) then
					self.selectMailIdOnRefresh = nextOrPreviousNode.data.mailId
				end
			end
			self:ConfirmDelete(self.mailId)
			return true
		end
	end
	return false
end)]]--

        --Подтверждение удаления предмета
ZO_PreHook("ZO_Dialogs_ShowPlatformDialog", function( ... )
	local name, data, textParams = ...
	if name == "CONFIRM_DESTROY_ITEM_PROMPT" then
		ZO_Dialogs_ShowPlatformDialog("DESTROY_ITEM_PROMPT", nil, textParams)
		return true
	end
end)

		--Поделиться всеми дейликами
		--UPD 0.0.7 - шара ТОЛЬКО локальных
function MirrorlandGuildHalls.ShareAllDailies()
	local QZone=GetPlayerActiveZoneName()
	local quest_count = 0
    for i = 1, GetNumJournalQuests() do
		if GetJournalQuestRepeatType(i) == QUEST_REPEAT_DAILY and GetIsQuestSharable(i) then
			if string.find(GetJournalQuestLocationInfo(i), QZone) then
				ShareQuest(i)
				d(MRR.."Делюсь заданием: "..'"'..GetJournalQuestName(i)..'"'.."|r")
				quest_count=quest_count+1
			end
		end
end
    if quest_count==0 then
        d(MRR.."Ну вот, даже поделиться нечем!|r")
    end
    if quest_count>=1 then
        d(MRR.."Заданий роздано: "..quest_count.."|r")
    end
	StartChatInput("Заданий роздано: "..quest_count.."", CHAT_CHANNEL_PARTY)
end

		--Сделай приятно зеркальцу, создай группу!
local function OnGroupCreate(eventCode, memberCharacterName, memberDisplayName, isLocalPlayer)
    if not IsUnitGrouped("player") then return end
    if isLocalPlayer then
        local groupSize = GetGroupSize()
        if groupSize == 2 then
			if not (IsUnitGroupLeader("player")) then
				d(MRR.."Правильно, в компании веселее!|r")
			else
				d(MRR.."Правильно, в компании веселее! Ой, да ты еще и главный!|r")
			end
        end
    end
end

		--Телепорт в зоны (from DailyHelper)
function MirrorlandGuildHalls.Teleport(zone)
	local porting=false
	local MLCzoneIndex = zone
	local MLCzoneName
				-----АЛЬЯНСЫ-----
	if MLCzoneIndex == 181 then
		MLCzoneName = LocGrahtwood
	elseif MLCzoneIndex == 4 then
		MLCzoneName = LocStormhaven
	elseif MLCzoneIndex == 10 then
		MLCzoneName = LocDeshaan
				-----НЕЙТРАЛЫ-----
	elseif MLCzoneIndex == 501 then
		MLCzoneName = LocCraglorn
	elseif MLCzoneIndex == 155 then
		MLCzoneName = LocCHarbour
				-----ГЛАВЫ-----
	elseif MLCzoneIndex == 468 then
		MLCzoneName = LocVvardenfell
	elseif MLCzoneIndex == 617 then
		MLCzoneName = LocSummerset
	elseif MLCzoneIndex == 682 then
		MLCzoneName = LocNortEls
	elseif MLCzoneIndex == 744 then
		MLCzoneName = LocWestSky
	elseif MLCzoneIndex == 835 then
		MLCzoneName = LocBlWood
	elseif MLCzoneIndex == 884 then
		MLCzoneName = LocHIsle
	end
		--Проверка членов группы
	for p=1, GetGroupSize() do
		local pTag=GetGroupUnitTagByIndex(p)
		if GetUnitZoneIndex(pTag)==zone and CanJumpToGroupMember(pTag) and porting==false and GetUnitDisplayName(pTag)~=GetUnitDisplayName("player") then
			JumpToGroupMember(GetUnitName(pTag))
			d(MRR.."|r|c0de3fc"..GetUnitDisplayName(pTag).."|r|cb8dbdd, а вы случайно не знаете, как нам выйти отсюда? Лишь бы куда-нибудь в|r "..MLCzoneName.."|cb8dbdd.|r")
			porting=true
			break
		end
	end
		--Проверка друзей
	if porting == false then
		for f=1, GetNumFriends() do
			local CharInfo = {}
			CharInfo.displayName, CharInfo.Note, CharInfo.status, CharInfo.secsSinceLogoff = GetFriendInfo(f)
			CharInfo.hasCharacter, CharInfo.characterName, CharInfo.zoneName, CharInfo.classType, CharInfo.alliance, CharInfo.level, CharInfo.championRank, CharInfo.zoneId = GetFriendCharacterInfo(f)
			if CharInfo.status~=PLAYER_STATUS_OFFLINE and GetZoneIndex(CharInfo.zoneId)==zone and porting==false and CharInfo.displayName~=GetUnitDisplayName("player") then
				JumpToFriend(CharInfo.displayName)
				d(MRR.."|r|c0de3fc"..CharInfo.displayName.."|r|cb8dbdd, а вы случайно не знаете, как нам выйти отсюда? Лишь бы куда-нибудь в|r "..MLCzoneName.."|cb8dbdd.|r")
				porting=true
				break
			end
		end
	end
		--Проверка гильдий
	if porting == false then
		for g=1, GetNumGuilds() do
			for m=1, GetNumGuildMembers(GetGuildId(g)) do
				local CharInfo = {}
				CharInfo.displayName, CharInfo.Note, CharInfo.GuildMemberRankIndex, CharInfo.status, CharInfo.secsSinceLogoff = GetGuildMemberInfo(GetGuildId(g), m)
				CharInfo.hasCharacter, CharInfo.characterName, CharInfo.zoneName, CharInfo.classType, CharInfo.alliance, CharInfo.level, CharInfo.championRank, CharInfo.zoneId = GetGuildMemberCharacterInfo(GetGuildId(g), m)
				CharInfo.guildIndex = g
				if CharInfo.status~=PLAYER_STATUS_OFFLINE and GetZoneIndex(CharInfo.zoneId)==zone and porting==false and CharInfo.displayName~=GetUnitDisplayName("player") then
					JumpToGuildMember(CharInfo.displayName)
					d(MRR.."|r|c0de3fc"..CharInfo.displayName.."|r|cb8dbdd, а вы случайно не знаете, как нам выйти отсюда? Лишь бы куда-нибудь в|r "..MLCzoneName.."|cb8dbdd.|r")
					porting=true
					break
				end
			end
		end
	end
		--Если никого нет
	if porting == false then d(MRR.."Не настаиваю, но, возможно, тебе стоит задуматься о расширении круга общения...|r") end
end

		--Телепорт в города
function MirrorlandGuildHalls.CityTeleport(node)
	local MLCnodeID = node
	if HasCompletedFastTravelNodePOI(node) then 
				-----АЛЬЯНСЫ-----
		if MLCnodeID == 214 then
			FastTravelToNode(214)
			d(MRR.."Ты знаешь, что такое безумие? Безумие - это платить|r |cffffff"..GetRecallCost(node).."|r"..GCN.." |cb8dbddза полёт в |r"..CityEldenRoot	.."|cb8dbdd.|r") --214
		elseif MLCnodeID == 56 then                                                                                                                             
			FastTravelToNode(56)                                                                                                                                
			d(MRR.."Ты знаешь, что такое безумие? Безумие - это платить|r |cffffff"..GetRecallCost(node).."|r"..GCN.." |cb8dbddза полёт в |r"..CityWayrest		.."|cb8dbdd.|r") --56
		elseif MLCnodeID == 28 then                                                                                                                             
			FastTravelToNode(28)                                                                                                                                
			d(MRR.."Ты знаешь, что такое безумие? Безумие - это платить|r |cffffff"..GetRecallCost(node).."|r"..GCN.." |cb8dbddза полёт в |r"..CityMournhold	.."|cb8dbdd.|r") --28
				-----НЕЙТРАЛЫ-----                                                                                                                              
		elseif MLCnodeID == 220 then                                                                                                                            
			FastTravelToNode(220)                                                                                                                               
			d(MRR.."Ты знаешь, что такое безумие? Безумие - это платить|r |cffffff"..GetRecallCost(node).."|r"..GCN.." |cb8dbddза полёт в |r"..CityBelkarth		.."|cb8dbdd.|r")
		elseif MLCnodeID == 131 then                                                                                                                            
			FastTravelToNode(131)                                                                                                                               
			d(MRR.."Ты знаешь, что такое безумие? Безумие - это платить|r |cffffff"..GetRecallCost(node).."|r"..GCN.." |cb8dbddза полёт в |r"..CityHollowCity	.."|cb8dbdd.|r")
				-----ГЛАВЫ-----                                                                                                                                 
		elseif MLCnodeID == 284 then                                                                                                                            
			FastTravelToNode(284)                                                                                                                               
			d(MRR.."Ты знаешь, что такое безумие? Безумие - это платить|r |cffffff"..GetRecallCost(node).."|r"..GCN.." |cb8dbddза полёт в |r"..CityVivec		.."|cb8dbdd.|r")
		elseif MLCnodeID == 355 then                                                                                                                            
			FastTravelToNode(355)                                                                                                                               
			d(MRR.."Ты знаешь, что такое безумие? Безумие - это платить|r |cffffff"..GetRecallCost(node).."|r"..GCN.." |cb8dbddза полёт в |r"..CityAlinor		.."|cb8dbdd.|r")
		elseif MLCnodeID == 382 then                                                                                                                            
			FastTravelToNode(382)                                                                                                                               
			d(MRR.."Ты знаешь, что такое безумие? Безумие - это платить|r |cffffff"..GetRecallCost(node).."|r"..GCN.." |cb8dbddза полёт в |r"..CityRimmen		.."|cb8dbdd.|r")
		elseif MLCnodeID == 421 then                                                                                                                            
			FastTravelToNode(421)                                                                                                                               
			d(MRR.."Ты знаешь, что такое безумие? Безумие - это платить|r |cffffff"..GetRecallCost(node).."|r"..GCN.." |cb8dbddза полёт в |r"..CitySolitude		.."|cb8dbdd.|r")
		elseif MLCnodeID == 458 then                                                                                                                            
			FastTravelToNode(458)                                                                                                                               
			d(MRR.."Ты знаешь, что такое безумие? Безумие - это платить|r |cffffff"..GetRecallCost(node).."|r"..GCN.." |cb8dbddза полёт в |r"..CityLeyawiin		.."|cb8dbdd.|r")
		CityGonfalon	=	'|cb58e49Знаменная Гавань|r'
		elseif MLCnodeID == 513 then                                                                                                                            
			FastTravelToNode(513)                                                                                                                               
			d(MRR.."Ты знаешь, что такое безумие? Безумие - это платить|r |cffffff"..GetRecallCost(node).."|r"..GCN.." |cb8dbddза полёт в |r"..CityGonfalon		.."|cb8dbdd.|r")
		end
	--don't have the wayshrine
	elseif not HasCompletedFastTravelNodePOI(node) then 
		d(MRR.."Боюсь, что до этого святилища придётся топать ножками...|r") 
	end
end

		--Initialize
local function HelloMessage()
	EVENT_MANAGER:UnregisterForEvent(MirrorlandGuildHalls.name, EVENT_PLAYER_ACTIVATED)
	CHAT_ROUTER:AddSystemMessage(MRR.."Эй, |c0de3fc"..GetUnitDisplayName("player").."|r|cb8dbdd, ты знаешь как долго мы с Королевой искали тебя?|r")
end

function MirrorlandGuildHalls:Initialize()
	self:InitializeChatButton()
	self:BagSpaceIndicator()
	SLASH_COMMANDS["/rl"] = function() ReloadUI() end
	SLASH_COMMANDS["/кд"] = function() ReloadUI() end
	SLASH_COMMANDS["/лидер"] = function() d(MRR.."Полетели на коронку!|r") JumpToGroupLeader() end
	SLASH_COMMANDS["/leader"] = function() d(MRR.."Полетели на коронку!|r") JumpToGroupLeader() end
	SLASH_COMMANDS["/вилла"] = function() MirrorlandGuildHalls:PortToHouse("@SiameseCat", 62) end
	SLASH_COMMANDS["/остров"] = function() MirrorlandGuildHalls:PortToHouse("@NataLiyaN", 62) end
	SLASH_COMMANDS["/пляж"] = function() MirrorlandGuildHalls:PortToHouse("@Mirror_Cat", 40) end
	SLASH_COMMANDS["/поместье"] = function() MirrorlandGuildHalls:PortToHouse("@Lost.Seeker", 46) end
	SLASH_COMMANDS["/h"] = function() d(MRR.."Дом, милый дом.|r") RequestJumpToHouse(GetHousingPrimaryHouse()) end
	SLASH_COMMANDS["/д"] = function() d(MRR.."Дом, милый дом.|r") RequestJumpToHouse(GetHousingPrimaryHouse()) end
	SLASH_COMMANDS["/дом"] = function() d(MRR.."Дом, милый дом.|r") RequestJumpToHouse(GetHousingPrimaryHouse()) end
end 
    
function MirrorlandGuildHalls.OnAddOnLoaded(event, addon)
    if addon == MirrorlandGuildHalls.name then
		EVENT_MANAGER:UnregisterForEvent(MirrorlandGuildHalls.name, EVENT_ADD_ON_LOADED)
		EVENT_MANAGER:RegisterForEvent(MirrorlandGuildHalls.name, EVENT_GROUP_MEMBER_JOINED, OnGroupCreate)
		EVENT_MANAGER:RegisterForEvent(MirrorlandGuildHalls.name, EVENT_PLAYER_ACTIVATED, HelloMessage)
		EVENT_MANAGER:RegisterForEvent(MirrorlandGuildHalls.name, EVENT_MAIL_OPEN_MAILBOX, BagUpdateSpace)	
		EVENT_MANAGER:RegisterForEvent(MirrorlandGuildHalls.name, EVENT_MAIL_TAKE_ATTACHED_ITEM_SUCCESS, BagUpdateSpace)
		EVENT_MANAGER:RegisterForEvent(MirrorlandGuildHalls.name, EVENT_MAIL_SEND_SUCCESS, BagUpdateSpace)
        MirrorlandGuildHalls:Initialize()
    end
	ZO_PreHookHandler(ZO_GuildHome,"OnEffectivelyShown",function()
		ZO_GuildHome_MLGH:SetHidden(not MirrorlandGuildHalls.Guilds[GUILD_SELECTOR.guildId])
	end)
	CALLBACK_MANAGER:RegisterCallback("OnGuildSelected",function()
		ZO_GuildHome_MLGH:SetHidden(not MirrorlandGuildHalls.Guilds[GUILD_SELECTOR.guildId])
	end)
	UI_Init()
end

EVENT_MANAGER:RegisterForEvent(MirrorlandGuildHalls.name, EVENT_ADD_ON_LOADED, MirrorlandGuildHalls.OnAddOnLoaded)